module Fishbone
  require 'erb'

  class Generator
    def initialize(opts)
      @options = opts
    end

    def root
      File.expand_path '../..', __FILE__
    end

    def aliases(options)
      if options[:capybara]
        capybara_aliases 
      else
        spec_aliases 
      end
    end

    def make_spec(options)
      local_aliases        = aliases(options)
      feature_name         = options[:feature] || "Give your feature a name"
      base_template        = File.read(options[:rspec]) if options[:rspec]
      before_all_template  = File.read(options[:before_all]) if options[:before_all]
      before_each_template = File.read(options[:before_each]) if options[:before_each]
      edge_template        = File.read(options[:edge]) if options[:edge]
      simple_template      = File.read(options[:simple]) if options[:simple]
      renderer             = ERB.new(base_template)
      renderer.result(binding)
    end

    def write_to_file(text_out)
      file = @options[:output]
      File.write(file, text_out)
    end

    def object
      obj_def = @options[:object]
      obj_template = File.read('./lib/templates/object.erb')
      renderer = ERB.new(obj_template)
      renderer.result(binding)
    end

    def spec_aliases
      { :level_one => 'describe',
        :level_two => 'it',
        :hook  => 'before'
      }
    end

    def capybara_aliases
      { :level_one => 'feature',
        :level_two => 'scenario',
        :hook  => 'background'
      }
    end
    
    def table_tests
      local_aliases = aliases(@options)
      test_def_template = File.read('./lib/templates/table.erb')
      renderer          = ERB.new(test_def_template)
      renderer.result(binding)
    end
  end
end




